<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 5.6 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="./">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">nightly-20250306-101218</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/nightly">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 5.6: Exercises</h1>
                    <p>
                        You will now practice what you have learned in this fourth module.
                        When modeling, there is generally not one correct answer, as multiple solutions are possible.
                        After you complete an exercise, an example solution is given, together with an explanation.
                    </p>

                    <h2>Exercise 1</h2>
                    <p>
                        A vending machine waits to receive an order.
                        Once a person presses on the button to start the order, it takes on average 12 second for the person to make a decision and pay.
                        After that, a product is selected and paid, and it takes 3 seconds for the vending machine to process everything.
                        When the vending machine is done processing, the order is retrieved in 4 seconds and the vending machine goes back to its waiting stage.
                    </p>
                    <p>
                        Make a model of the vending machine.
                        Do not use the variable <code>time</code>, but instead use a continuous variable to define when the automaton should go to the next location.
                    </p>
                    <div class="accordion" id="exercise1-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise1-solution" aria-expanded="false" aria-controls="exercise1-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise1-solution" class="accordion-collapse collapse" data-bs-parent="#exercise1-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton VendingMachine:
                                                event order;
                                                cont t der 1;

                                                location Idle:
                                                    initial;
                                                    marked;
                                                    edge order do t := 0.0 goto Decision;

                                                location Decision:
                                                    edge when t >= 12 do t := 0.0 goto Processing;

                                                location Processing:
                                                    edge when t >= 3 do t := 0.0 goto Retrieving;

                                                location Retrieving:
                                                    edge when t >= 4 goto Idle;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The automaton waits for the <code>order</code> event to occur.
                                        This event can come at any time.
                                    </p>
                                    <p>
                                        Then, a series of activities occurs, each of which is timed.
                                        Since we don't care about the event for these edges, we implicitly use event <code>tau</code>.
                                        To be able to use relative times, we reset continuous variable <code>t</code> before each timed activity.
                                        We do not reset it when we go back to <code>Idle</code>, as it is not necessary, since the edges in that location doesn't use <code>t</code> and resets it becomes necessary for the next location.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 2</h2>
                    <p>
                        Consider again the <a href="urgency.html#water-level">water level model</a> that was used earlier in the module to demonstrate a timed livelock.
                        Change the model as follows:
                    </p>
                    <ul>
                        <li>Fix the livelock.</li>
                        <li>Change the water level, such that it is between 0 and 25 meters.</li>
                        <li>Change the rise and drop velocity of the water to 5 meters per minute, assuming the time unit of the model is in minutes.</li>
                    </ul>
                    <div class="accordion" id="exercise2-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise2-solution" aria-expanded="false" aria-controls="exercise2-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise2-solution" class="accordion-collapse collapse" data-bs-parent="#exercise2-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton WaterLevel:
                                                event rise, drop;
                                                cont level;

                                                location Rising:
                                                    initial;
                                                    marked;
                                                    equation level' = 5;
                                                    edge drop when level >= 25 goto Dropping;

                                                location Dropping:
                                                    equation level' = -5;
                                                    edge rise when level <= 0  goto Rising;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        We use two locations, one for rising and one for dropping water levels.
                                        We use the derivative of the water's <code>level</code> to specify the velocity, instead of using a discrete variable.
                                        We have edges that indicate when to go to the other location.
                                        These edges are only enabled once the automaton should switch locations, and thus there is no timed livelock.
                                    </p>
                                    <p>
                                        We opted for equations per location for the velocity of the water level rising and dropping.
                                        This way the values are tied to the locations directly.
                                        We could have also specified it with the declaration, using an <code>if</code> or <code>switch</code> expression.
                                    </p>
                                    <p>
                                        The model behaves as follows, for the first 40 time units:
                                    </p>
                                    <img src="images/exercise2-solution-plot.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 3</h2>
                    <p>
                        Consider a basketball (shown as a brown circle) being thrown at a backboard (shown as a large rectangle), bouncing off that backboard, and going through the hoop (also known as the ring, shown as a red line):
                    </p>
                    <img src="images/basketball-visualization.png">
                    <p>
                        Some files for this exercise can be found in the course files, in the <code>basketball</code> folder of the <code>module5</code> folder:
                    </p>
                    <ul>
                        <li><code>basketball.cif</code>: The model of the behavior of the basketball, which is to be completed.</li>
                        <li><code>basketball.svg</code>: The SVG image shown above, which is used for visualization and interaction.</li>
                        <li><code>simulation.cif</code>: The simulation model for the basketball, which is to be completed.</li>
                        <li><code>simulation.tooldef</code>: The simulation script to easy start the simulation.</li>
                    </ul>
                    <p>
                        A player will throw the basketball against the backboard, such that it bounces off it and goes through the hoop.
                        A part of the basketball's behavior is already modeled in <code>basketball.cif</code>:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton basketball:
                                uncontrollable u_throw;

                                cont x der ...

                                cont y der ...

                                location Rest:
                                    initial;
                                    marked;
                                    edge u_throw goto Thrown;

                                location Thrown:
                                    edge ...
                            end
                        </code>
                    </pre>
                    <p>
                        Initially the basketball is in <code>Rest</code> at the position shown in the image above.
                        The basketball can be thrown by the player with the <code>u_throw</code> event.
                        It is then thrown and flies linearly through the air towards the backboard.
                        The basketball's position is modeled by its <code>x</code> and <code>y</code> coordinates.
                        Once the ball goes through the hoop, the simulation automatically resets back to its resting state.
                        You need to adapt the parts indicated by <code>...</code> to complete the model.
                    </p>
                    <p>
                        In <code>simulation.cif</code>, the visualization and interaction is defined:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            import "basketball.cif";
                            svgfile "basketball.svg";

                            const real SCALE_FACTOR = 10;

                            svgin id "basketball" event basketball.u_throw;

                            svgout id "basketball" attr "transform"
                                value fmt("translate(%s, -%s)", ... * SCALE_FACTOR, ... * SCALE_FACTOR);
                        </code>
                    </pre>
                    <p>
                        The <code>u_throw</code> is coupled to a click on the basketball.
                        The position of the basketball is partially defined by the SVG output mapping.
                        You need to still fill in the <code>...</code> parts.
                    </p>
                    <div class="accordion" id="exercise3-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise3-solution" aria-expanded="false" aria-controls="exercise3-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise3-solution" class="accordion-collapse collapse" data-bs-parent="#exercise3-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>basketball.cif</code> file can be adapted as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton basketball:
                                                uncontrollable u_throw;

                                                cont x der switch self:
                                                               case Rest:    0.0
                                                               case Thrown:  2.5
                                                               case Bounced: 3.5
                                                           end;

                                                cont y der switch self:
                                                               case Rest:     0.0
                                                               case Thrown:   3.0
                                                               case Bounced: -3.0
                                                           end;

                                                location Rest:
                                                    initial;
                                                    marked;
                                                    edge u_throw goto Thrown;

                                                location Thrown:
                                                    edge when y >= 6 goto Bounced;

                                                location Bounced:
                                                    edge when x >= 8 do x := 0, y := 0 goto Rest;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The <code>simulation.cif</code> file can be adapted as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "basketball.cif";
                                            svgfile "basketball.svg";

                                            const real SCALE_FACTOR = 10;

                                            svgin id "basketball" event basketball.u_throw;

                                            svgout id "basketball" attr "transform"
                                                value fmt("translate(%s, -%s)", basketball.x * SCALE_FACTOR, basketball.y * SCALE_FACTOR);
                                        </code>
                                    </pre>
                                    <p>
                                        We set the derivatives such that the linear movement after throwing goes to the blackboard, and the linear movement after bouncing goes through the hoop.
                                        We use two separate locations for them, to allow having different derivatives for the two movements.
                                        For the simulation model, we simply fill in the coordinates of the basketball.
                                    </p>
                                    <p>
                                        The simulation then looks something like this:
                                    </p>
                                    <img src="images/basketball-animation.gif">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 4</h2>
                    <p>
                        Consider again the <a href="continuous-variables.html#phone-model">phone model</a> from earlier in the module.
                        You will now make a more realistic model of a phone, that allows using and charging the phone as long as you want, and even simultaneously.
                    </p>
                    <p>
                        An SVG image file named <code>phone.svg</code> can be found in the course files, in the <code>phone</code> folder of the <code>module5</code> folder:
                    </p>
                    <img src="images/phone-visualization.png">
                    <p>
                        The rectangle with rounded borders represents the phone.
                        At its top right is the battery indicator, both as a light-blue bar and as a text.
                        At the bottom is its power connector.
                        The power connector is connected to the charging cable.
                        The charging cable is connected to the charger, the bottom-right box with the charging icon.
                    </p>
                    <p>
                        <strong>a. Model the behavior of the phone that can be used and charged.</strong>
                    </p>
                    <p>
                        Model the phone's behavior in <code>phone.cif</code>, taking into account the following:
                    </p>
                    <ul>
                        <li</li>
                        <li>Use two events for toggling usage of the phone and the charger being connected.</li>
                        <li>Track the usage of the phone and the charger being connected using discrete variables.</li>
                        <li>The phone is initially fully charged, not being used and the charging cable is disconnected.</li>
                        <li>The phone charges with 8% per time unit, while using the phone requires 5% of the battery's capacity per time unit.</li>
                        <li>If the battery has no charge left, the phone can't be used.</li>
                        <li>The battery can't be less than empty or more than 100% charged.</li>
                    </ul>
                    <div class="accordion" id="exercise4a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise4a-solution" aria-expanded="false" aria-controls="exercise4a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise4a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise4a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>phone.cif</code> file could look like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton phone:
                                                uncontrollable u_usage_toggle;
                                                uncontrollable u_charger_connected_toggle;

                                                disc bool is_using = false;
                                                disc bool is_connected = false;

                                                alg real charge_increase = if is_connected: 8 else 0 end;
                                                alg real usage_decrease  = if is_using:     5 else 0 end;
                                                alg real total_increase  = charge_increase - usage_decrease;
                                                alg real battery_delta   =
                                                            if   battery_percentage <= 0   and total_increase < 0: 0
                                                            elif battery_percentage >= 100 and total_increase > 0: 0
                                                            else                                                   total_increase
                                                            end;

                                                cont battery_percentage = 100 der battery_delta;

                                                location:
                                                    initial;
                                                    edge u_usage_toggle when battery_percentage > 0 do is_using := not is_using;
                                                    edge when battery_percentage <= 0 and is_using do is_using := false;
                                                    edge u_charger_connected_toggle do is_connected := not is_connected;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The phone has a <code>u_usage_toggle</code> event to toggle using the phone.
                                        It also has a <code>u_charger_connected_toggle</code> event to toggle the charger being connected to the phone.
                                        The events are uncontrollable as the user decides when they want to use the phone or when the connect or disconnect the charging cable.
                                    </p>
                                    <p>
                                        The <code>is_using</code> variable tracks usage of the phone, while the <code>is_connected</code> variable tracks whether the charging cable is connected.
                                        Initially, the phone is not being used and the charging cable is disconnected, so both variables are initially <code>false</code>.
                                    </p>
                                    <p>
                                        We then define various algebraic variables.
                                        Variable <code>charge_increase</code> indicates the increase of the battery percentage per unit, due to the charging cable being connected.
                                        If the charging cable is connected, the increase is <code>8</code> percent per unit.
                                        If the charging cable is disconnected, the battery percentage does not increase.
                                        Similarly, <code>usage_decrease</code> indicates whether the battery percentage decreases per time unit, and how much.
                                        The <code>total_increase</code> variable accounts for both usage and charging, which may be active at the same time.
                                        Finally, <code>battery_delta</code> accounts for the fact that the battery percentage must at all times remain between 0 and 100 percent.
                                        That is, we can't be more empty than fully empty, and we can't charge an already fully charged phone.
                                    </p>
                                    <p>
                                        The current battery percentage is tracked in the <code>battery_percentage</code> continuous variable.
                                        Initially, the phone is fully charged, so the battery percentage is <code>100</code> percent.
                                        The derivative is defined to be <code>battery_delta</code>.
                                    </p>
                                    <p>
                                        There is a single location with three edges.
                                        The first edge handles the <code>u_usage_toggle</code> event.
                                        It flips the <code>is_using</code> variable.
                                        However, you can use the phone when the battery is fully drained, so then the phone can't be used.
                                        We thereby also disallow to stop using the phone when the battery is fully drained, but this is OK, because that is already handled by the second edge.
                                    </p>
                                    <p>
                                        The second edge ensures that if the phone's battery is fully drained, we stop using the phone, even if the user doesn't want to.
                                        This edge uses a <code>tau</code> event, which is not influenced by anything the user can do.
                                    </p>
                                    <p>
                                        The third edge handles the <code>u_charger_connected_toggle</code> event.
                                        It flips the <code>is_connected</code> boolean.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Create a simulation model for the phone.</strong>
                    </p>
                    <p>
                        Model the phone's behavior in <code>simulation.cif</code>, taking into account the following:
                    </p>
                    <ul>
                        <li>Connect the event to toggle the charger being connected to the charger, which has id <code>charger</code>.</li>
                        <li>Connect the event to toggle the usage of the phone to the phone's screen, which has id <code>phone-screen</code>.</li>
                        <li>
                            Ensure the battery percentage text is correctly updated based on the state of the phone.
                            The battery percentage text element has id <code>battery-percentage</code>.
                        </li>
                        <li>
                            Ensure the battery level (light-blue bar) correctly displays the battery status.
                            The rectangle has id <code>battery-level</code>.
                            If the phone is fully charged, the height of this rectangle should be <code>3.16</code>.
                        </li>
                        <li>Ensure that the phone's screen is <code>white</code> is the phone is being used, and is <code>black</code> otherwise.</li>
                        <li>
                            Ensure that the charger cable is visible when it is connected, and is invisible otherwise.
                            The charger cable has id <code>charger-cable</code>.
                            Hint: Use the <code>display</code> attribute, with value <code>inherit</code> to show the element and <code>none</code> to hide the element.
                        </li>
                    </ul>
                    <p>
                        Hint: Note that negative heights are invalid in SVG, so you may need to cap certain values.
                    </p>
                    <div class="accordion" id="exercise4b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise4b-solution" aria-expanded="false" aria-controls="exercise4b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise4b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise4b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>simulation.cif</code> file could look like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "phone.cif";
                                            svgfile "phone.svg";

                                            svgin id "charger"      event phone.u_charger_connected_toggle;
                                            svgin id "phone-screen" event phone.u_usage_toggle;

                                            svgout id "battery-percentage" text value fmt("%.0f%%", capped_percentage);
                                            svgout id "battery-level" attr "height" value scale(capped_percentage, 0, 100, 0, 3.16);
                                            svgout id "phone-screen" attr "fill" value if phone.is_using: "white" else "black" end;
                                            svgout id "charger-cable" attr "display" value if phone.is_connected: "inherit" else "none" end;

                                            alg real capped_percentage = min(max(phone.battery_percentage, 0), 100);
                                        </code>
                                    </pre>
                                    <p>
                                        We import the phone's behavior from <code>phone.cif</code>.
                                        We connect the simulation model to the <code>phone.svg</code> image.
                                    </p>
                                    <p>
                                        We connect the interactive events to the interactive elements of the image using two SVG input mappings.
                                    </p>
                                    <p>
                                        There are four SVG output mappings, one for each element that requires visualization.
                                        The battery percentage text is set using an SVG output mapping that sets the text based on a format pattern.
                                        The <code>%.0f</code> part of the pattern formats the value as a floating point number with zero digits after the decimal, so as whole numbers.
                                        The <code>%%</code> part of the pattern inserts an escaped percentage character.
                                    </p>
                                    <p>
                                        The battery level bar is set by scaling the percentage, which is in the range 0 to 100, to the height of the bar, which is 0 to 3.16.
                                        The phone's screen is set to the right color, and the charger cable is shown or hidden.
                                    </p>
                                    <p>
                                        To prevent a negative height for the battery level bar's rectangle, we cap the battery percentage of the phone to be at least zero.
                                        We also cap it to be at most 100, to prevent a too high bar.
                                        We therefore define <code>capped_percentage</code>, which is minimally <code>0</code>, by taking the maximum of the battery percentage and <code>0</code>.
                                        It is also maximally 100, by taking the minimum of the bottom-capped percentage and <code>100</code>.
                                        We use this bottom-and-top-capped percentage for both the height of the phone's bar rectangle, and for the battery percentage text.
                                        This also prevents displaying percentage texts that are less than zero or higher than 100.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>C. Simulate the phone's behavior, and check that it is correct.</strong>
                    </p>
                    <p>
                        Create a ToolDef script to simulate the phone's behavior and interact with it via the SVG image.
                        Try various scenarios, such as combinations of the phone being in use or not in use, and the charging cable being connected and disconnected.
                        Also, check what happens when the phone gets fully depleted, or becomes fully charged.
                    </p>
                    <div class="accordion" id="exercise4c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise4c-solution" aria-expanded="false" aria-controls="exercise4c-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise4c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise4c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>simulation.tooldef</code> file could look like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="tooldef">
                                            from "lib:cif" import *;

                                            cifsim(
                                                "simulation.cif",
                                                "--input-mode=svg",
                                                "--auto-algo=first",
                                                "--frame-rate=60",
                                                "--option-dialog=no",
                                            );
                                        </code>
                                    </pre>
                                    <p>
                                        The model should work as expected.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 5</h2>
                    <p>
                        Consider again the elevator model from <a href="../module4/exercises.html#exercise3">Exercise 3</a> and <a href="../module4/exercises.html#exercise7">Exercise 7</a> of the previous module.
                        The final model after Exercise 7 of the previous module is provided in the course files, in the <code>elevator</code> folder of the <code>module5</code> folder.
                        This is the model with the building that has three floors, the elevator, a sensor at each floor to detect whether the elevator is at that floor, and a button at each floor to request the elevator to move to that floor.
                        The state of the plant is visualized, and the button are connected to events.
                        We continue with this model, adding timing for the movement of the elevator, and synthesizing a supervisor to control it based on the floor requests.
                    </p>
                    <p>
                        <strong>a. Separate the plants and requirements from the simulation model.</strong>
                    </p>
                    <p>
                        The current model contains the plant, as well as connections to the SVG image for simulation.
                        We want to add timing for the simulation, but timed models are not supported for synthesis.
                        Therefore, separate the plant model from the simulation model.
                        Make sure to still have a scalable simulation model.
                    </p>
                    <div class="accordion" id="exercise5a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5a-solution" aria-expanded="false" aria-controls="exercise5a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>elevator.cif</code> file with the plant model could look like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Sensor(alg bool initialOn; alg bool isOn):
                                                uncontrollable u_on, u_off;

                                                location Off:
                                                    initial not initialOn;
                                                    marked not initialOn;
                                                    edge u_on  when     isOn goto On;

                                                location On:
                                                    initial initialOn;
                                                    marked initialOn;
                                                    edge u_off when not isOn goto Off;
                                            end

                                            sensor_top:    Sensor(false, elevator.floorNr = 3);
                                            sensor_middle: Sensor(false, elevator.floorNr = 2);
                                            sensor_bottom: Sensor(true,  elevator.floorNr = 1);

                                            plant def Button():
                                                uncontrollable u_pushed, u_released;

                                                location Released:
                                                    initial;
                                                    marked;
                                                    edge u_pushed goto Pushed;

                                                location Pushed:
                                                    edge u_released goto Released;
                                            end

                                            button_top:    Button();
                                            button_middle: Button();
                                            button_bottom: Button();

                                            plant def Observer(event request; alg bool atFloor):
                                                uncontrollable u_reset;

                                                location NotRequested:
                                                    initial;
                                                    marked;
                                                    edge request goto Requested;

                                                location Requested:
                                                    edge u_reset when atFloor goto NotRequested;

                                            end

                                            observer_top:    Observer(button_top.u_pushed,    sensor_top.On);
                                            observer_middle: Observer(button_middle.u_pushed, sensor_middle.On);
                                            observer_bottom: Observer(button_bottom.u_pushed, sensor_bottom.On);

                                            plant elevator:
                                                controllable c_up, c_down;
                                                disc int[1..3] floorNr = 1;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge c_up   when floorNr < 3 do floorNr := floorNr + 1;
                                                    edge c_down when floorNr > 1 do floorNr := floorNr - 1;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The SVG file declaration has been removed, as well as the SVG input and output mappings.
                                        The no longer needed algebraic parameters of the automaton definitions are also removed.
                                        And the automaton instantiations have been updated to no longer provide arguments for these removed parameters.
                                    </p>
                                    <p>
                                        The <code>simulation.cif</code> file with the SVG image connections could look like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "elevator.cif";
                                            svgfile "elevator-with-buttons.svg";

                                            group def SensorSim(alg bool sensorOn; alg string floorName):
                                                svgout id "sensor-" + floorName attr "display" value if sensorOn: "inherit" else "none" end;
                                            end

                                            sensor_sim_top:    SensorSim(sensor_top.On,    "top");
                                            sensor_sim_middle: SensorSim(sensor_middle.On, "middle");
                                            sensor_sim_bottom: SensorSim(sensor_bottom.On, "bottom");

                                            group def ObserverSim(alg bool observerNotRequested; alg string floorName; event request):
                                                svgout id "button-" + floorName attr "fill" value if observerNotRequested: "red" else "limegreen" end;
                                                svgin id "button-" + floorName event request;
                                            end

                                            observer_sim_top:    ObserverSim(observer_top.NotRequested,    "top",    button_top.u_pushed);
                                            observer_sim_middle: ObserverSim(observer_middle.NotRequested, "middle", button_middle.u_pushed);
                                            observer_sim_bottom: ObserverSim(observer_bottom.NotRequested, "bottom", button_bottom.u_pushed);

                                            group elevator_sim:
                                                svgout id "elevator" attr "y" value <string>(((3 - elevator.floorNr) * 50) + 10);
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The simulation model is imported, and the SVG file declaration is moved to the simulation model.
                                        For the sensors and observers, group definitions are included.
                                        They are group definitions, as they only contain the SVG input/output mappings, not any behavior.
                                    </p>
                                    <p>
                                        The <code>SensorSim</code> definition for sensor simulation gets the relevant information as parameters.
                                        It makes sure the floor sensor is correctly shown or hidden.
                                        This SVG output mapping is nearly the same as the one we removed from the plant model, except that the 'sensor is on' status is accessed via the <code>sensorOn</code> parameter.
                                        The three instantiations use names similar to the instantiations of the sensors, but with <code>sim</code> in them, to avoid having multiple components with the same name.
                                    </p>
                                    <p>
                                        The observer definitions and instantiations are similar.
                                        By using group definitions and instantiations, we ensure there is still reuse, even though the SVG input and output mappings are now defined separately from the plant behavior.
                                    </p>
                                    <p>
                                        The elevator is also put in a group, to have it be similar to the sensor and observer simulation groups.
                                        It contains the single SVG output mapping that positions the elevator on the right floor.
                                        It is nearly the same as the one we removed from the plant model, except that the <code>floor</code> number is now accessed from the <code>elevator</code>.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Add timing to the movement of the elevator.</strong>
                    </p>
                    <p>
                        Adapt the plant model to account for the up and down movements taking time.
                        Adapt the simulation model to make sure that it takes two time units for the elevator to move to a different floor.
                    </p>
                    <div class="accordion" id="exercise5b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5b-solution" aria-expanded="false" aria-controls="exercise5b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>elevator</code> plant automaton is adapted as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant elevator:
                                                controllable c_up, c_down;
                                                uncontrollable u_arrived;
                                                disc int[1..3] floorNr = 1;

                                                location Idle:
                                                    initial;
                                                    marked;
                                                    edge c_up   when floorNr < 3 and any_sensor_on goto GoingUp;
                                                    edge c_down when floorNr > 1 and any_sensor_on goto GoingDown;

                                                location GoingUp:
                                                    edge u_arrived do floorNr := floorNr + 1 goto Idle;

                                                location GoingDown:
                                                    edge u_arrived do floorNr := floorNr - 1 goto Idle;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The <code>c_up</code> and <code>c_down</code> events no longer immediately lead to reaching a different floor.
                                        Instead, they lead to a different location, where the elevator is going up or down.
                                        A new uncontrollable event <code>u_arrived</code> indicates that the next floor is reached.
                                        The event is uncontrollable as the controller can't prevent reaching the floor once the movement has commenced.
                                        And we must specify the controllability of the event in the plant model, as synthesis requires it.
                                        Once the elevator arrives at the next floor, the <code>floorNr</code> is updated, and the elevator is <code>Idle</code> again.
                                    </p>
                                    <p>
                                        The up and down movements are only allowed once any sensor is on.
                                        This prevents moving between floors and never turning on the sensor for that floor.
                                        This is important to make sure that the observers can be reset.
                                        We thus introduce this <code>any_sensor_on</code> variable, while also adapting the sensors themselves:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            sensor_top:    Sensor(false, elevator.floorNr = 3 and elevator.Idle);
                                            sensor_middle: Sensor(false, elevator.floorNr = 2 and elevator.Idle);
                                            sensor_bottom: Sensor(true,  elevator.floorNr = 1 and elevator.Idle);

                                            alg bool any_sensor_on = sensor_top.On or sensor_middle.On or sensor_bottom.On;
                                        </code>
                                    </pre>
                                    <p>
                                        Algebraic variable <code>any_sensor_on</code> is true if any of the sensors is on.
                                        We also add a <code>and elevator.Idle</code> condition for sensors to go on, since the floor is now only updated after having completed a move.
                                        This takes time, and during that time, the floor number still indicates the old floor.
                                        The sensor must however go off as soon as the elevator leaves the floor.
                                    </p>
                                    <p>
                                        The <code>elevator_sim</code> group in the simulation model is adapted as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton elevator_sim:
                                                cont t der 1;

                                                location Idle:
                                                    initial;
                                                    edge elevator.c_up, elevator.c_down do t := 0 goto Moving;

                                                location Moving:
                                                    edge elevator.u_arrived when t >= 2 goto Idle;

                                                svgout id "elevator" attr "y" value <string>(((3 - elevator.floorNr) * 50) + 10);
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The group is changed to an automaton, to allow adding behavior to it.
                                        There is a continuous variable <code>t</code> to track time passage.
                                        There are two locations, <code>Idle</code> and <code>Moving</code>.
                                        There is no need to have separate locations for going up and down, as the time for both is the same.
                                        If we either go up or down, we set <code>t</code> to <code>0</code> to start measuring time from that moment forward, and we go to the <code>Moving</code> location.
                                        There we wait for two time units, before we enable the <code>u_arrived</code> event.
                                        This way, the plant automaton <code>elevator</code> gets restricted and has to wait as well, as they both synchronize over the <code>u_arrived</code> event.
                                        Once the elevator arrived, it goes back to being <code>Idle</code> again.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>c. Adapt the visualization to make the elevator move continuously between floor.</strong>
                    </p>
                    <div class="accordion" id="exercise5c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5c-solution" aria-expanded="false" aria-controls="exercise5c-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>elevator_sim</code> automaton in <code>simulator.cif</code> could be adapted as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton elevator_sim:
                                                cont t der 1;

                                                const real duration = 2;

                                                alg real simFloorNr = elevator.floorNr + switch elevator:
                                                                                             case Idle:        0
                                                                                             case GoingUp:     t / duration
                                                                                             case GoingDown: -(t / duration)
                                                                                         end;

                                                location Idle:
                                                    initial;
                                                    edge elevator.c_up, elevator.c_down do t := 0 goto Moving;

                                                location Moving:
                                                    edge elevator.u_arrived when t >= duration goto Idle;

                                                svgout id "elevator" attr "y" value <string>(((3 - simFloorNr) * 50) + 10);
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        Instead of using <code>elevator.floorNr</code>, the SVG output mapping now uses <code>simFloorNr</code>.
                                        The new <code>simFloorNr</code> algebraic variable adds to the <code>elevator.floorNr</code> the partial movement to another floor.
                                        If the <code>elevator</code> is <code>Idle</code>, there is no partial movement.
                                        Otherwise, it is the timer value <code>t</code>, divided by two, as in two time units it moves one floor.
                                        The value is positive or negative, depending on the direction in which the elevator is moving.
                                        We opt to put the value <code>2</code> in a constant, to be able to more easily adapt it.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>d. Add requirements to ensure that the elevator only moves when requested, and goes to the right floor.</strong>
                    </p>
                    <p>
                        Add the requirement to the plant model.
                        Synthesize a supervisor from the plants and requirements.
                        Adapt the simulation model use the synthesized controlled system, rather than the plant and requirements model.
                        Check that the elevator works as expected.
                    </p>
                    <div class="accordion" id="exercise5d-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5d-solution" aria-expanded="false" aria-controls="exercise5d-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5d-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5d-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>elevator.cif</code> model is extended with requirements:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement elevator.c_up
                                                needs (elevator.floorNr = 1 and (observer_top.Requested or observer_middle.Requested))
                                                   or (elevator.floorNr = 2 and  observer_top.Requested);

                                            requirement elevator.c_down
                                                needs (elevator.floorNr = 3 and (observer_bottom.Requested or observer_middle.Requested))
                                                   or (elevator.floorNr = 2 and  observer_bottom.Requested);
                                        </code>
                                    </pre>
                                    <p>
                                        The elevator may go from floor the bottom floor if either the top or middle floor requests the elevator.
                                        It may also go up from the middle floor if the top floor requests the elevator.
                                        Going down is similarly constrained.
                                    </p>
                                    <p>
                                        The <code>simulation.cif</code> model gets its import statement replaced:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "elevator.ctrlsys.cif";
                                        </code>
                                    </pre>
                                    <p>
                                        It imports the result of synthesis, the controlled system model, rather than the model with plants and requirements.
                                    </p>
                                    <p>
                                        Simulating the simulation model, you can see that the elevator only moves if requested.
                                        And it only goes to floors to which is requested.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="tau-event.html">Go back to Module 5.5</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="water-lock-case-hybrid-model.html">Proceed to Module 5.7</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
